//Features:
//
//Adds component palette pages onto its popup menu
//
//Adds support for multi-line component palette
//
//Adds support for hot-tracking on the component palette
//
//Adds support for using buttons instead of component palette tabs
//
//Adds a Window menu
//
//Adds option for non-flat speedbuttons
//
//Adds options for getting to Object Inspector & main IDE window
//from form designer
//
//Makes visible a number of normally hidden menu items:
//  Search | Show Last Compile Error
//    View | View as Text
//    Help | How to Use Help
//    Help | Windows API

//Various states are stored in the registry under
//HKEY_CURRENT_USER\Software\Oblong\Archaeopteryx
//There is an optional entry "Tab Height" which defaults
//to the normal tab height (16 on my laptop). This is used to
//decide how much to increase/decrease the IDE window when going
//into or out of multiline mode. You can find that when using
//button style tabs that you need a bigger value (the
//problem arises when there are several rows). 19 works for me
//
//Another optional entry is "Window Menu Caption" which
//defaults to "W&indow" to allow you to avoid shortcut key
//clashes and also avoid possible multiple menus with the same
//("Window") caption

unit Bones;

interface

implementation

//Just in case I want to generate a version with
//a subset of the functionality, I have a bunch
//of $defines which control which of these
//independent units will be compiled in

{$define WindowMenu}
{$define PalettePopup}
{$define PaletteTweaking}
{$define HiddenMenus}
{$define NonFlatButtons}

uses
  {$ifdef HiddenMenus}HiddenMenus,{$endif}
  {$ifdef NonFlatButtons}NonFlatButtons,{$endif}
  {$ifdef PalettePopup}PalettePopup,{$endif}
  {$ifdef PaletteTweaking}PaletteTweaking,{$endif}
  {$ifdef WindowMenu}WindowMenu,{$endif}
  Messages;

end.
