unit SysCmdU;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    ChkDesign: TCheckBox;
    Button1: TButton;
    procedure Edit1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Edit1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

const
  Delta = 5;
  sc_DragMove = sc_Move + 1;
  sc_Left = 1;
  sc_Right = 2;
  sc_Top = 3;
  sc_Bottom = 6;
  sc_SizeKeys = sc_Size + 0;
  sc_SizeLeft = sc_Size + sc_Left;
  sc_SizeRight = sc_Size + sc_Right;
  sc_SizeTop = sc_Size + sc_Top;
  sc_SizeBottom = sc_Size + sc_Bottom;
  sc_SizeTopLeft = sc_SizeTop + sc_Left;
  sc_SizeTopRight = sc_SizeTop + sc_Right;
  sc_SizeBottomLeft = sc_SizeBottom + sc_Left;
  sc_SizeBottomRight = sc_SizeBottom + sc_Right;

function GetSizeCommand(X, Y: Integer; Control: TWinControl): Cardinal;
begin
  Result := sc_Size;
  if X > Control.ClientWidth - Delta then 
    Inc(Result, sc_Right)
  else if X < Delta then
    Inc(Result, sc_Left);
  if Y > Control.ClientHeight - Delta then
    Inc(Result, sc_Bottom)
  else if Y < Delta then
    Inc(Result, sc_Top)
end;

procedure TForm1.Edit1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  SystemCode: Cardinal;
begin
  with Sender as TWinControl do
    if ChkDesign.Checked and (ssCtrl in Shift) then
    begin
      SystemCode := GetSizeCommand(X, Y, TWinControl(Sender));
      if SystemCode <> sc_Size then
      begin
        { Do fake mouse button release, since }
        { the control won't notice the }
        { real one due to its resizing }
        Perform(wm_LButtonUp, X, Y);
        Perform(wm_SysCommand, SystemCode, 0);
      end
    end
    else
    begin
      ReleaseCapture;
      Perform(wm_SysCommand, sc_DragMove, 0);
    end;
end;

procedure TForm1.Edit1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
  NewCursor: TCursor;
begin
  NewCursor := crDefault;
  with Sender as TWinControl do
  begin
    if ChkDesign.Checked and (ssCtrl in Shift) then
      case GetSizeCommand(X, Y, Sender as TWinControl) of
        sc_SizeTop, sc_SizeBottom: NewCursor := crSizeNS;
        sc_SizeLeft, sc_SizeRight: NewCursor := crSizeWE;
        sc_SizeTopLeft, sc_SizeBottomRight: NewCursor := crSizeNWSE;
        sc_SizeTopRight, sc_SizeBottomLeft: NewCursor := crSizeNESW;
      end;
    Cursor := NewCursor
  end
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  Perform(wm_SysCommand, sc_ContextHelp, 0)
end;

end.
